#include <stdio.h>
#include <stdlib.h>
#include <i86.h>
#include <string.h>
#include <math.h>
#include <conio.h>

void AsmLine(unsigned char *addr,    // write address
             int fixadd,             // fixed increment
             int acc,                // accumulator
             int speed,              // acc speed
             int col,                // current color
             int colspeed);          // color increment

int AsmLine_n;                       // number of pixels to draw
int AsmLine_m;                       // acc threshold
int AsmLine_varadd;                  // variable increment

#pragma aux AsmLine=\
  "  push ebp"\
  "  mov  ebp,AsmLine_n"\
  "  and  esi,0xFFFFFF00"\
  "L1:"\
  "  mov dl,byte ptr [edi]"\
  "  add edx,esi"\
  "  jge L5"\
  "  and edx,0x000000FF"\
  "L5:"\
  "  xor ecx,0x1800000"\
  "  cmp dl,64"\
  "  jge L3"\
  "  push edx"\
  "  add edx,ecx"\
  "  rol edx,8"\
  "  mov byte ptr [edi],dl"\
  "  pop edx"\
  "  jmp L4"\
  "L3:"\
  "  lea edx,[edx+esi*2]"\
  "L4:"\
  "  add edi,eax"\
  "  dec ebp"\
  "  je  L2"\
  "  add bx,cx"\
  "  jle L1"\
  "  xor ecx,0x1800000"\
  "  add edi,AsmLine_varadd"\
  "  sub bx,word ptr AsmLine_m"\
  "  jmp L1"\
  "L2:"\
  "  pop ebp"\
  parm [edi] [eax] [ebx] [ecx] [edx] [esi]\
  modify [edi edx ebx]

unsigned char *video;
int  maxx,maxy;

void Line(int x0,int y0,int x1,int y1)
{
  int dx,ix,dy,iy,c,s,delta;
  if (x0<x1) { dx=x1-x0; ix=1; } else { dx=x0-x1; ix=-1; }
  if (y0<y1) { dy=y1-y0; iy=maxx; } else { dy=y0-y1; iy=-maxx; }
  c=62<<24;
  delta=(((x0+y0)&1) ? 0 : 0x1800000);
  if (dx>dy)
    {
      s=(dx==0 ? 0 : (1<<22)*sqrt(1+(float)(dy*dy)/(dx*dx)));
      AsmLine_n=dx+1;
      AsmLine_varadd=iy;
      AsmLine_m=dx;
      AsmLine(video+y0*maxx+x0,
              ix,
              delta-dx>>1,
              dy,
              c,
              -s);
    }
  else
    {
      s=(dy==0 ? 0 : (1<<22)*sqrt(1+(float)(dx*dx)/(dy*dy)));
      AsmLine_n=dy+1;
      AsmLine_varadd=ix;
      AsmLine_m=dy;
      AsmLine(video+y0*maxx+x0,
              iy,
              delta-dy>>1,
              dx,
              c,
              -s);
    }
}

void Box(int x0,int y0,int x1,int y1,int c)
{
  unsigned char *d;
  if ( y0<0 ) y0=0; if (x0<0) x0=0;
  if ( y1>maxy ) y1=maxy; if (x1>maxx) x1=maxx;
  if ( x0<x1 && y0<y1 )
  {
    d=video+y0*maxx+x0;
    x1-=x0;
    do
    {
      memset(d,c,x1);
      d+=maxx;
    } while (++y0<y1);
  }
}

void Print(char *s,int x,int y,int sc,int c)
{
  unsigned char *b;
  int i,j,k;
  while ( *s )
  {
    b=(unsigned char *)0xFFA6E+(*s++)*8;
    for ( i=0; i<8; i++ )
    {
      for ( k=*b++,j=0; j<8; j++ )
      {
        if ( k&0x80 )
          Box(x+j*sc,y+i*sc,x+j*sc+sc,y+i*sc+sc,c);
        k<<=1;
      }
    }
    x+=8*sc;
  }
}


void main(void)
{
  union REGS r;
  int x,y,i,j,t,n;
  r.w.ax=0x13; int386(0x10,&r,&r);
  maxx=320; maxy=200;
  video=malloc(maxx*maxy); //(unsigned char *)0xA0000;
  memset(video,0,maxx*maxy);

  /*
  for (i=100; i<150; i++)
    for (j=150; j<200; j++)
      video[i*maxx+j]=64;
  */

  outp(0x3C8,0);
  for ( i=0; i<64; i++ )
  {
    j=i*2-32;
    if (j<0) j=0; if (j>63) j=63;
    outp(0x3C9,i);
    outp(0x3C9,i);
    outp(0x3C9,j);
  }
  outp(0x3C9,0);
  outp(0x3C9,0);
  outp(0x3C9,0);


  Print("The light",  10,10,3,64);
  Print("Is not",     10,10+3*8,3,64);
  Print("The absence",10,10+3*8*2,3,64);
  Print("Of a shadow",10,10+3*8*3,3,64);

  x=160; y=100;
  n=0; t=*(int *)0x46C;
  while (*(short *)0x041A==*(short *)0x041C)
  {
    r.w.cx=r.w.dx=0; r.w.ax=0x0B; int386(0x33,&r,&r);
    x+=(short)r.w.cx; y+=(short)r.w.dx;
    if ( x<0 ) x=0; if (x>maxx-1) x=maxx-1;
    if ( y<0 ) y=0; if (y>maxy-1) y=maxy-1;
    for (i=0; i<maxx; i++)
    {
      Line(x,y,i,0);
      Line(x,y,i,maxy-1);
    }
    for (i=0; i<maxy; i++)
    {
      Line(x,y,0,i);
      Line(x,y,maxx-1,i);
    }
    memcpy((unsigned char *)0xA0000,video,maxx*maxy);
    n++;
  }
  t=*(int *)0x46C-t;
  r.w.ax=0x03; int386(0x10,&r,&r);
  printf("%0.3f frame/sec.\n",(float)n/(t/18.181818));
}
