#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>
#include <i86.h>
#include <string.h>
#include <time.h>

double AtomX[1000],AtomY[1000],AtomSX[1000],AtomSY[1000];
int   LinkFrom[1000],LinkTo[1000];
double LinkLen[1000];
int   NLink,NAtom;

int NewLink(int a1,int a2,double len)
{
  if (NLink<1000)
    {
      LinkFrom[NLink]=a1; LinkTo[NLink]=a2;
      LinkLen[NLink++]=len;
      return NLink-1;
    }
  return -1;
}

int NewAtom(double x,double y,double sx,double sy)
{
  if (NAtom<1000)
    {
      AtomX[NAtom]=x; AtomY[NAtom]=y;
      AtomSX[NAtom]=sx; AtomSY[NAtom++]=sy;
      return NAtom-1;
    }
  return -1;
}

float KE,KD;

void Update(void)
{
  int a1,a2,i;
  double s,dx,dy,l;
  //
  // Update atom position
  //
  for (i=0; i<NAtom; i++)
    {
      AtomX[i]+=AtomSX[i];
      AtomY[i]+=AtomSY[i];
      if (AtomY[i]>200)
	{ AtomSY[i]=-AtomSY[i];
	  AtomY[i]+=AtomSY[i];
	}
/*
      if (AtomX[i]>320 || AtomX[i]<0)
	{ AtomSX[i]=-AtomSX[i];
	  AtomX[i]+=AtomSX[i];
	}
*/
/*
      AtomSX[i]=3+(AtomSX[i]-3)*0.99+(rand()%255)/255;
*/
/*
      AtomSX[i]=1+(AtomSX[i]-1)*0.9;
*/
      AtomSY[i]+=0.01;
/*
      AtomSX[i]*=0.995;
      AtomSY[i]*=0.995;
*/
      if (AtomY[i]>190)
	AtomSX[i]*=0.90;
      else
	AtomSX[i]*=0.995;
      AtomSY[i]*=0.995;
    }

  //
  // Update links
  //
  for (i=0; i<NLink; i++)
    {
      a1=LinkFrom[i]; a2=LinkTo[i];
      dx=AtomX[a2]-AtomX[a1];
      dy=AtomY[a2]-AtomY[a1];
      l=sqrt(fabs(dx*dx+dy*dy)); dx/=l; dy/=l;

      s=(l-LinkLen[i]); s=s/4;
      AtomSX[a2]-=s*dx; AtomSY[a2]-=s*dy;
      AtomSX[a1]+=s*dx; AtomSY[a1]+=s*dy;
/*
      s=(LinkLen[i]-l)/2; s=s*(1-KE/(1+s*s/KD));
      AtomX[a2]+=s*dx; AtomY[a2]+=s*dy;
      AtomX[a1]-=s*dx; AtomY[a1]-=s*dy;
*/
    }
}

unsigned char Video[64000];

void Line(int x0,int y0,int x1,int y1,int c)
{
    int dx,dy,ix,iy,cx,cy,i,m;

    if (x0<x1) { dx=x1-x0; ix=1; } else { dx=x0-x1; ix=-1; }
    if (y0<y1) { dy=y1-y0; iy=1; } else { dy=y0-y1; iy=-1; }
    if (dx<dy) m=dy; else m=dx;
    cx=cy=i=m; dx<<=1; dy<<=1; m<<=1;
    if (i>100) i=100;
    while (i-->=0)
    {
	if (x0>=0 && x0<320 && y0>=0 && y0<200)
	  Video[y0*320+x0]=c;
	if ((cx+=dx)>=m) { cx-=m; x0+=ix; }
	if ((cy+=dy)>=m) { cy-=m; y0+=iy; }
    }
}

void VideoInit(void)
{
    union REGS r;

    r.w.ax=0x0013; int386(0x10,&r,&r);
}

void VideoClose(void)
{
    union REGS r;

    r.w.ax=0x0003; int386(0x10,&r,&r);
}

void Pixel(int x,int y,int c)
{
  if (x>=0 && y>=0 && x<320 && y<200)
    Video[y*320+x]=c;
}

void main(void)
{
    union REGS r;
    int xx,yy,i,j,A[11][11];
    double dx,dy;

    VideoInit();

//    memset(Video,0,64000);
//    for (j=0; j<100; j++)
//	{
//	  xx=j<<8; yy=0;
//	  for (i=0; i<319; i++)
//	    {
//	      Pixel(i,100+(xx>>8),10);
//	      xx+=yy; yy-=xx>>8;
//	    }
//	}
//    memmove((void *)0xA0000,Video,64000);
//    getch();


//    //
//    // Build a chain
//    //
//    NewAtom(0,0,0,0);
//    for (j=1; j<20; j++)
//	NewLink(j-1,NewAtom(j*10,0,0,0),10);

    //
    // Build a net
    //
    for (i=0; i<=10; i++)
      for (j=0; j<=10; j++)
 				A[i][j]=NewAtom(i*10 /*-120*/ ,j*10,1,0); //2+(j-5)/30.0,(5-i)/30.0);
    for (i=0; i<10; i++)
      for (j=0; j<=10; j++)
				{
				  NewLink(A[i][j],A[i+1][j],10);
				  NewLink(A[j][i],A[j][i+1],10);
					if (j<10)
				  {
				    NewLink(A[j][i],A[j+1][i+1],sqrt(10*10+10*10));
				    NewLink(A[j][i+1],A[j+1][i],sqrt(10*10+10*10));
				  }
				}

    xx=0; yy=0;

    KE=0.5; KD=10000;
    while (1)
      {
	//
	// Draw current position
	//
	memset(Video,0,64000);

	for (i=0; i<NLink; i++)
	  {
	    Line(AtomX[LinkFrom[i]],AtomY[LinkFrom[i]],
		 AtomX[LinkTo[i]],AtomY[LinkTo[i]],
		 7);
	  }

/*
	for (i=0; i<NAtom; i++)
	  {
	    Line(AtomX[i]-2,AtomY[i]-2,AtomX[i]+2,AtomY[i]-2,4);
	    Line(AtomX[i]+2,AtomY[i]-2,AtomX[i]+2,AtomY[i]+2,4);
	    Line(AtomX[i]+2,AtomY[i]+2,AtomX[i]-2,AtomY[i]+2,4);
	    Line(AtomX[i]-2,AtomY[i]+2,AtomX[i]-2,AtomY[i]-2,4);
	  }
*/
	for (i=0; i<NAtom; i++)
	  {
	    Pixel(AtomX[i],AtomY[i],4);
	  }
	memmove((void *)0xA0000,Video,64000);

	//
	// Update phisics
	//
	Update();

	//
	// Force "boundary"
	//
//	  for (i=0; i<=10; i+=2)
//	      { AtomX[A[0][i]]=0;
//		AtomY[A[0][i]]=i*10;
//	      }

/*
	AtomX[A[0][0]]=xx; AtomY[A[0][0]]=yy;
	AtomX[A[0][1]]=xx; AtomY[A[0][1]]=yy+10;
	AtomX[A[1][1]]=xx+10; AtomY[A[1][1]]=yy+10;
	AtomX[A[1][0]]=xx+10; AtomY[A[1][0]]=yy;
*/
/*
	for (i=0; i<=10; i++)
	  { AtomX[A[0][i]]=xx;
	    AtomY[A[0][i]]=yy+i*10;
	    AtomSX[A[0][i]]=AtomSY[A[0][i]]=0;
	  }
*/
	r.w.ax=0x000B; r.w.cx=0; r.w.dx=0; int386(0x33,&r,&r);
	dx=(short)r.w.cx; dy=(short)r.w.dx;
	xx+=dx; yy+=dy;
	if (dx!=0 || dy!=0)
	  {
	    for (i=0; i<NAtom; i++)
	      {
		AtomSX[i]+=dx/1000.0;
		AtomSY[i]+=dy/1000.0;
	      }
	  }
	if (xx<0) xx=0; if (yy<0) yy=0;
	if (xx>320) xx=320; if (yy>200) yy=200;

	if (kbhit())
	  {
	    i=getch(); if (i==0) i=-getch();
	    switch(i)
	      {
		case -72: KE=KE+0.01; break;
		case -80: KE=KE-0.01; break;
		case -75: KD=KD+100; break;
		case -77: KD=KD-100; break;
	      }
	    if (i==27)
	      break;
	  }
      }
    VideoClose();
//  printf("KE=%0.3f, KD=%0.3f\n",KE,KD);
		puts("Jello... (try it with a mouse if you didn't)");
		puts("");
		puts("By Andrew Griffini ... mailto:agriff@tin.it");
		puts("                       http://netservers.com/~agriff");
}
