{$N+}
{$G+}
uses U64k,PlasmaU,Crt2;

type Image=array[0..199,0..319] of byte;

const NDIST=50;
      KPERSP=24;
      HEIGHT=12;

      yy00:integer=50;

var img,col:^TMap;
    oldy,oldc:array[0..319] of integer;
    buf:^Image;
    LoRes:boolean;
    www1,www:integer;
    time:integer;

procedure Line(x0,y0,x1,y1:longint; den:integer);
var dx,dy,ca,cb:longint;
    hhh,t,j,ya,yb,ly,css,oc,oy,a,b,y,c,i:integer;
begin
  if LoRes then hhh:=80
           else hhh:=160;
  dx:=(x1-x0) div hhh;
  dy:=(y1-y0) div hhh;
  inc(x0,dx div 2);
  inc(y0,dy div 2);
  for i:=0 to hhh-1 do begin
      t:=i shl 1;
      asm
          mov  es,word ptr [Img+2]
          mov  bl,byte ptr [x0+2]
          mov  bh,byte ptr [y0+2]

          (* Easy way *)
{
          mov  ah,es:[bx]
          xor  al,al
          shr  ax,7
}
          (* Interpolated way *)
          xor  ax,ax
          xor  dx,dx
          mov  al,es:[bx+1]
          mov  dl,es:[bx-1]
          mov  cx,dx
          sub  ax,dx
          mov  dx,word ptr [x0]
          shl  ax,1
          shr  dx,1
          imul dx
          add  cx,dx

          xor  ax,ax
          xor  dx,dx
          mov  al,es:[bx+256]
          mov  dl,es:[bx-256]
          add  cx,dx
          sub  ax,dx
          mov  dx,word ptr [y0]
          shl  ax,1
          shr  dx,1
          imul dx
          add  cx,dx

          mov  ax,cx

          neg  ax
          sar  ax,1
          sub  ax,YY00
          cwd
          mov  dl,ah
          mov  ah,al
          xor  al,al
          idiv den

          add  ax,100

          mov  y,ax

          mov  es,word ptr [Col+2]

          (* Easy way *)
{
          mov  ch,es:[bx]
          mov  cl,0
}
          (* Interpolated way *)
          xor  ax,ax
          xor  dx,dx
          mov  ah,es:[bx+1]
          mov  dh,es:[bx-1]
          mov  cx,dx
          sub  ax,dx
          mov  dx,word ptr [x0]
          shl  ax,1
          shr  dx,1
          imul dx
          add  cx,dx

          xor  ax,ax
          xor  dx,dx
          mov  ah,es:[bx+256]
          mov  dh,es:[bx-256]
          add  cx,dx
          sub  ax,dx
          mov  dx,word ptr [y0]
          shl  ax,1
          shr  dx,1
          imul dx
          add  cx,dx

          shr  cx,1

          mov  ax,den
          shl  ax,2
          sub  cx,ax
          jae  @@Ok1
          xor  cx,cx
        @@Ok1:

          mov  c,cx

        end;

      inc(x0,dx); inc(y0,dy);

      if y<0 then y:=0; if y>200 then y:=200;

      oy:=oldy[t]; oc:=oldc[t];
      if y>oy then begin
          css:=(c-oc) div (y-oy);

          if y<0 then y:=0;
{
          buf^[oy,i*2]:=oc shr 8;
          buf^[oy,i*2+1]:=oc shr 8;
          oy:=y;
}
{
          while (oy<y)and(oy<200) do begin
              buf^[oy,t]:=oc shr 8;
              buf^[oy,t+1]:=oc shr 8;
              inc(oc,css);
              inc(oy)
            end
}
          if LoRes then
            asm
                les  di,buf
                mov  ax,oy
                shl  ax,2
                add  ax,oy
                shl  ax,6

                add  di,ax
                add  di,t
                add  di,t
                mov  cx,y
                cmp  cx,200
                jle  @@OkY
                mov  cx,200
              @@OkY:
                sub  cx,oy
                jle  @@Done
                mov  bx,oc
                mov  dx,css
              @@Loop1:
                mov  ax,bx
                shr  ax,1
                mov  al,ah
                adc  al,0
                mov  es:[di],ax
                mov  es:[di+2],ax

                add  di,320
                add  bx,dx
                dec  cx
                jne  @@Loop1
              @@Done:
              end
          else
            asm
                les  di,buf
                mov  ax,oy
                shl  ax,2
                add  ax,oy
                shl  ax,6

                add  di,ax
                add  di,t
                mov  cx,y
                cmp  cx,200
                jle  @@OkY
                mov  cx,200
              @@OkY:
                sub  cx,oy
                jle  @@Done
                mov  bx,oc
                mov  dx,css
              @@Loop1:
                mov  ax,bx
                shr  ax,1
                mov  al,ah
                adc  al,0
                mov  es:[di],ax

                add  di,320
                add  bx,dx
                dec  cx
                jne  @@Loop1
              @@Done:
              end;
        end;
      oldy[t]:=y;
      oldc[t]:=c
    end
end;

var CTab,STab:array[0..2047] of longint;

procedure CalcRot;
var i,j:integer;
begin
  for i:=0 to 2047 do begin
      CTab[i]:=round(65536*cos(i*2*PI/2048));
      STab[i]:=round(65536*sin(i*2*PI/2048))
    end
end;

const AP=2048 div 8;

var Shadows:array[1..10,-3..3,-3..3] of byte;
    Shadow0:array[-3..3,-3..3] of integer;

procedure CalcShadow;
var d,i,j:integer;
begin
  for i:=-3 to 3 do
    for j:=-3 to 3 do begin
        d:=round(64*sqrt(sqr(i/3.5)+sqr(j/3.5)));
        if d>63 then d:=63;
        Shadow0[i,j]:=d
      end
end;

procedure Shadow(n:integer; x,y:longint);
var c,a,b,i,j:integer;
begin
  for i:=-3 to 3 do
    for j:=-3 to 3 do begin
        a:=((x shr 16)+i) and 255;
        b:=((y shr 16)+j) and 255;
        c:=Col^[b,a];
        Shadows[n,i,j]:=c;
        Col^[b,a]:=c*Shadow0[i,j] div 63;
      end
end;

procedure UnShadow(n:integer; x,y:longint);
var i,j,a,b:integer;
begin
  for i:=-3 to 3 do
    for j:=-3 to 3 do begin
        a:=((x shr 16)+i) and 255;
        b:=((y shr 16)+j) and 255;
        Col^[b,a]:=Shadows[n,i,j]
      end
end;

var oyy:integer;

function CalcHeight(xv,yv:longint):integer;
var aaa:integer;
begin
  asm
      mov  es,word ptr [Img+2]
      mov  bl,byte ptr [xv+2]
      mov  bh,byte ptr [yv+2]

      (* Interpolated way *)
      xor  ax,ax
      xor  dx,dx
      mov  al,es:[bx+1]
      mov  dl,es:[bx-1]
      mov  cx,dx
      sub  ax,dx
      shl  ax,1
      mov  dx,word ptr [xv]
      shr  dx,1
      imul dx
      add  cx,dx

      xor  ax,ax
      xor  dx,dx
      mov  al,es:[bx+256]
      mov  dl,es:[bx-256]
      add  cx,dx
      sub  ax,dx
      shl  ax,1
      mov  dx,word ptr [yv]
      shr  dx,1
      imul dx
      add  cx,dx

      shr  cx,1
      neg  cx
      mov  aaa,cx
    end;
  CalcHeight:=aaa
end;

function CalcYS(h:integer; den:integer):integer;
var y:integer;
begin
  asm
          mov  ax,h
          sub  ax,YY00
          cwd
          mov  dl,ah
          mov  ah,al
          xor  al,al
          idiv den

          add  ax,100

          mov  y,ax
    end;
  CalcYS:=y
end;

var Sphere:array[-15..15,-15..15] of integer;

procedure CalcSphere;
var i,j:integer;
    x,y,z,c:real;
begin
  for i:=-15 to 15 do begin
      for j:=-15 to 15 do begin
          y:=i/15.5;
          x:=j/15.5;
          z:=1.0-x*x-y*y;
          if z<0 then Sphere[i,j]:=-1
                 else begin
                     z:=sqrt(z);
                     c:=z*0.4;
                     x:=x*z*2; y:=y*z*2; z:=z*z*2-1;
                     z:=(z-y*2)*0.3; if z>0 then c:=c+z;
                     if c<0 then c:=0; if c>1 then c:=1;
                     Sphere[i,j]:=191-round(48*(1-c))
                   end
        end
    end
end;

var SkyZ:array[0..99] of longint;

procedure DrawSky(xx,yy:longint; aa:integer);
var hhh,y1,light,y:integer;
    cs1,sn1,cs,sn,z,xx0,yy0,vvx,vvy:longint;
    texture:word;
begin
  xx:=xx shl 6; yy:=yy shl 6;
{
  xx:=longint(time) shl 24; yy:=0;
}
  texture:=seg(buf64k^);
  cs:=CTab[(aa-AP)and 2047];
  sn:=STab[(aa-AP)and 2047];
  if LoRes then hhh:=160 else hhh:=320;
  cs1:=(CTab[(aa+AP)and 2047]-cs) div hhh;
  sn1:=(STab[(aa+AP)and 2047]-sn) div hhh;

  for y:=0 to 99 do begin
{
      xx0:=x0[a]^[y]+xx; yy0:=y0[a]^[y]+yy;
      vvx:=vx[a]^[y]; vvy:=vy[a]^[y];
}
      z:=SkyZ[y];
      xx0:=z*cs+xx;
      yy0:=z*sn+yy;
      vvx:=z*cs1;
      vvy:=z*sn1;

{
      light:=(y+255-199) shr 1;
      light:=light or (light shl 8);
}
      if LoRes then
        asm
                les  di,buf
                mov  ax,y
                shl  ax,2
                add  ax,y
                shl  ax,6
                add  di,ax
                mov  cx,word ptr [xx0+2]
                mov  dx,word ptr [yy0+2]
                mov  ax,word ptr [vvx]
                mov  word ptr [@@Const11+3],ax
                mov  ax,word ptr [vvy]
                mov  word ptr [@@Const21+3],ax
                mov  si,160
                push ds
                mov  ds,Texture
            @@Loop1:
                mov  bl,dh
                mov  bh,ch
                mov  al,[bx]
                shr  al,2
                mov  ah,al
                or   ax,$4040
                stosw
            @@Const11:
                add  word ptr [xx0],$1dfc
                adc  cx,word ptr [vvx+2]
            @@Const21:
                add  word ptr [yy0],$1dfc
                adc  dx,word ptr [vvy+2]
                dec  si
                jne  @@Loop1
                pop  ds
          end
      else
        asm
                les  di,buf
                mov  ax,y
                shl  ax,2
                add  ax,y
                shl  ax,6
                add  di,ax
                mov  cx,word ptr [xx0+2]
                mov  dx,word ptr [yy0+2]
                mov  ax,word ptr [vvx]
                mov  word ptr [@@Const11+3],ax
                mov  word ptr [@@Const12+3],ax
                mov  ax,word ptr [vvy]
                mov  word ptr [@@Const21+3],ax
                mov  word ptr [@@Const22+3],ax
                mov  si,160
                push ds
                mov  ds,Texture
            @@Loop1:
                mov  bl,dh
                mov  bh,ch
                mov  al,[bx]
                shr  al,2
            @@Const11:
                add  word ptr [xx0],$1dfc
                adc  cx,word ptr [vvx+2]
            @@Const21:
                add  word ptr [yy0],$1dfc
                adc  dx,word ptr [vvy+2]
                mov  bl,dh
                mov  bh,ch
                mov  ah,[bx]
                shr  ah,2
                or   ax,$4040
                stosw
            @@Const12:
                add  word ptr [xx0],$1dfc
                adc  cx,word ptr [vvx+2]
            @@Const22:
                add  word ptr [yy0],$1dfc
                adc  dx,word ptr [vvy+2]
                dec  si
                jne  @@Loop1
                pop  ds
          end
    end
end;

const s:string='7613';
      owww:integer = -1;

procedure View(xv,yv:longint; a:integer);
var w1,w,aaa,j,i,k:integer;
    xo,yo,x0,y0,x1,y1:longint;
begin
  asm
          les  di,buf
          add  di,32000
          db   $66,$B8,$7f,$7f,$7f,$7f    (* mov eax,07F7F7F7Fh *)
          cld
          mov  dx,100
      @@Loop1:
          mov  cx,80
          db   $F3,$66,$AB	          (* rep stosd *)
          db   $66,$2D,$01,$01,$01,$01    (* sub  eax,001010101h *)
          dec  dx
          jne  @@Loop1
    end;

  DrawSky(xv,yv,a);

  xo:=xv+20*CTab[a and 2047];
  yo:=yv+20*STab[a and 2047];

  Shadow(1,xo,yo);

  for i:=0 to 319 do begin
      oldy[i]:=200;
      oldc[i]:=-32768
    end;

  aaa:=CalcHeight(xv,yv)-50;
  inc(yy00,(aaa-yy00) div 4);
  if yy00>aaa then yy00:=aaa;

  i:=NDIST;
  repeat
    j:=1+i*i div KPERSP;
    x0:=xv+CTab[(a-AP) and 2047]*j;
    y0:=yv+STab[(a-AP) and 2047]*j;
    x1:=xv+CTab[(a+AP) and 2047]*j;
    y1:=yv+STab[(a+AP) and 2047]*j;
    dec(i);
    if i=28 then begin
        inc(time);
        aaa:=CalcHeight(xo,yo);
        inc(oyy,(aaa-200-oyy-CTab[(time*128) and 2047] div 1024) div 4);
        if oyy>aaa-60 then oyy:=aaa-60;
        aaa:=CalcYS(oyy,32*256 div HEIGHT)-15;
        asm
                les  di,buf
                mov  ax,aaa
                mov  dx,320
                mul  dx
                add  di,ax
                add  di,160-15
                mov  dx,31
                mov  si,offset Sphere
                cld
            @@Loop1:
                cmp  aaa,200
                jae  @@Skip
                mov  cx,31
            @@Loop2:
                lodsw
                cmp  ax,0
                jl   @@Ok1
                mov  es:[di],al
            @@Ok1:
                inc  di
                dec  cx
                jne  @@Loop2
                add  di,320-31
                inc  aaa
                dec  dx
                jne  @@Loop1
                jmp  @@Done
            @@Skip:
                add  di,320
                add  si,62
                inc  aaa
                dec  dx
                jne  @@Loop1
            @@Done:
          end
      end;
    Line(x0,y0,x1,y1,j*longint(256) div HEIGHT)
  until (i=1);
{
  while i<NDIST do begin
      buf^[0,(NDIST-i)*2]:=63;
      inc(i)
    end;
}
  UnShadow(1,xo,yo);
  for i:=0 to length(s)-1 do
    for j:=0 to 7 do begin
        k:=mem[$FFA6:14+ord(s[i+1])*8-8+j];
        for w:=0 to 7 do begin
            if k and 1<>0 then buf^[192+j,320-32+i*8+7-w]:=63;
            k:=k shr 1
          end
      end;
  if owww<>www then begin
      w:=160; w1:=320-w*2
    end
  else begin
      w:=owww; w1:=320-w*2
    end;
  owww:=www;
  asm
          mov  es,SegA000
          mov  di,160
          sub  di,W
{
          xor  di,di
}
          push ds
          lds  si,buf
          add  si,160
          sub  si,W
          mov  dx,200
          cld
      @@Loop1:
          mov  cx,W
          rep  movsw
          add  si,W1
          add  di,W1
          dec  dx
          jne  @@Loop1

{
          mov  cx,4000

       @@Loop1:

          db   $66,$8B,$04
          db   $66,$26,$89,$05
          db   $66,$8B,$44,$04
          db   $66,$26,$89,$45,$04
          db   $66,$8B,$44,$08
          db   $66,$26,$89,$45,$08
          db   $66,$8B,$44,$0C
          db   $66,$26,$89,$45,$0C
          add  si,16
          add  di,16
          dec  cx
          jne  @@Loop1
}
{
          mov  cx,16000
          cld
          db   $F3,$66,$A5			 (* rep movsd *)
}
          pop  ds
    end

end;

var r,g,b,j,i,aa,a:integer;
    xx0,yy0,k:longint;
    mouse,mdx,mdy:integer;
BEGIN
  for i:=0 to 99 do
    SkyZ[i]:=round(100*20000.0/(110-i));
  CalcSphere;
  img:=buf64k;
  col:=buf64k2;

  Plasma(img^);

  new(buf);
  asm mov ax,$13; int $10 end;
  port[$3C8]:=0;
  for i:=0 to 63 do begin
      r:=i;
      g:=i;
      b:=i-8;
      if r<0 then r:=0; if r>63 then r:=63; port[$3C9]:=r;
      if g<0 then g:=0; if g>63 then g:=63; port[$3C9]:=g;
      if b<0 then b:=0; if b>63 then b:=63; port[$3C9]:=b
    end;
  for i:=0 to 63 do begin
      r:=63-i;
      g:=63-i;
      b:=63-i*2 div 3;
      if r<0 then r:=0; if r>63 then r:=63; port[$3C9]:=r;
      if g<0 then g:=0; if g>63 then g:=63; port[$3C9]:=g;
      if b<0 then b:=0; if b>63 then b:=63; port[$3C9]:=b
    end;
  for i:=0 to 63 do begin
      r:=i;
      g:=i-16;
      b:=i-48;
      if r<0 then r:=0; if r>63 then r:=63; port[$3C9]:=r;
      if g<0 then g:=0; if g>63 then g:=63; port[$3C9]:=g;
      if b<0 then b:=0; if b>63 then b:=63; port[$3C9]:=b
    end;
{
  for i:=0 to 255 do
    for j:=0 to 255 do
      img^[i,j]:=img^[i,j] shr 1;
}
  for i:=0 to 255 do
    for j:=0 to 255 do
{
      if img^[i,j]=0 then col^[i,j]:=1
                     else }
                          col^[i,j]:=64+(img^[i,j]-img^[i,(j-1)and 255])
                                        shl 1;

  CalcRot;
  xx0:=0; yy0:=0; aa:=0; k:=15;
  i:=0;
  a:=64;
  asm mov ax,0; int $33; mov mouse,ax end;
  YY00:=-1000;
  oyy:=-1000;
  CalcShadow; www:=160; www1:=0;
  LoRes:=FALSE;
  repeat
    inc(a,aa); View(xx0,yy0,a);
    inc(xx0,CTab[a and 2047]*k div 10);
    inc(yy0,STab[a and 2047]*k div 10);
    if mouse<>0 then begin
        asm mov ax,$000b; int $33; mov mdx,cx; mov mdy,dx end;
        if (abs(mdx)>2) or (abs(mdy)>2) then begin
            k:=0;
            aa:=0;
            inc(a,mdx);
            dec(xx0,CTab[a and 2047]*mdy div 10);
            dec(yy0,STab[a and 2047]*mdy div 10)
          end
      end;
    while keypressed do begin
        i:=ord(readkey); if i=0 then i:=-ord(readkey);
        case i of
            -75: dec(aa,2);
            -77: inc(aa,2);
            -72: inc(k);
            -80: dec(k);
             60: if www>0 then begin
                     dec(www); inc(www1,2);
                     fillchar(buf^,sizeof(Image),0)
                   end;
             62: if www<160 then begin inc(www); dec(www1,2) end;
             33: LoRes:=not LoRes
          end
      end
  until i=27;
  asm mov ax,$03; int $10 end;
END.
